"======================================================================
|
| Copyright 2004 Mike Anderson
| Written by Mike Anderson
|
| This file is part of Mumble, a development environment for GNU Smalltalk.
|
| Mumble is free software; you can redistribute it and/or modify it
| under the terms of the GNU General Public License as published by the Free
| Software Foundation; either version 2, or (at your option) any later version.
| 
| Mumble is distributed in the hope that it will be useful, but WITHOUT
| ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
| FOR A PARTICULAR PURPOSE.  See the GNU General Public License for more
| details.
| 
| You should have received a copy of the GNU General Public License along with
| Mumble; see the file COPYING.  If not, write to the Free Software
| Foundation, 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.  
|
 ======================================================================
"

WindowedView subclass: #Dialog
	instanceVariableNames: 'dlg vbox entry result runSemaphore parent '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Browser-Dialogs'!

!Dialog methodsFor: 'accessing'!

parent: aParent
    parent := aParent
!

result
    ^result
!
!

!Dialog methodsFor: 'initialization'!

buildWidgets
    super buildWidgets.
    dlg := GtkDialog new.
    dlg on: 'response' send: #response:arg1: to: self.
!
!

!Dialog methodsFor: 'running'!

destroy
    dlg destroy.
	dlg := nil.
!

response: aSender arg1: aArg1 
    result := aArg1.
	runSemaphore signal.
!

run
    | process |
    "^dlg run"

    dlg isNil ifTrue: [ self buildWidgets ].

    process := Processor activeProcess.

    parent notNil ifTrue: [ dlg setTransientFor: parent ].
    dlg 
		setModal: true;
		show.

    runSemaphore := Semaphore new.

    "If we're about to suspend the event loop, we'll need another"
    (process name match: 'call-in process')
		ifTrue: [ Gtk newDispatcher ].

    result := nil.
    runSemaphore wait.

    dlg
		setModal: false;
		hide.
    ^result
!
!
