"======================================================================
|
| Copyright 2004 Mike Anderson
| Written by Mike Anderson
|
| This file is part of Mumble, a development environment for GNU Smalltalk.
|
| Mumble is free software; you can redistribute it and/or modify it
| under the terms of the GNU General Public License as published by the Free
| Software Foundation; either version 2, or (at your option) any later version.
| 
| Mumble is distributed in the hope that it will be useful, but WITHOUT
| ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
| FOR A PARTICULAR PURPOSE.  See the GNU General Public License for more
| details.
| 
| You should have received a copy of the GNU General Public License along with
| Mumble; see the file COPYING.  If not, write to the Free Software
| Foundation, 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.  
|
 ======================================================================
"


TreeData subclass: #ExplorerData
	instanceVariableNames: 'rootNode'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XML - display'!
!

ExplorerData methodsFor: 'accessing'!

getCols: aNode
    | desc detail |
    aNode isText ifTrue: 
		[ aNode isBlankText
			ifTrue: [ detail := '(whitespace)' ]
			ifFalse: [ detail := aNode text copyFrom: 1 to: aNode text size ].
		((aNode text size < 100)
			ifTrue: [ aNode isBlankText ifFalse: [ detail := '"', aNode text, '"' ] ]
			ifFalse: 
				[ detail := detail,
					' (', aNode text size printString, 
					' chars long)' ]). ].
    aNode isElement ifTrue: 
		[ desc := aNode simpleDescription ].
    aNode isAttribute ifTrue: 
		[ (#('start' 'end') anySatisfy: [ :a | a match: aNode tag asString ]) 
			ifTrue: 
				[ detail := (self dateFromUnixSeconds: aNode value asNumber) printString ]
			ifFalse: 
				[ detail := aNode value ]. ].
    (desc isNil and: [ aNode tag notNil ]) ifTrue: 
		[ desc := aNode tag printString ].
    desc isNil ifTrue: 
		[ desc := aNode class name printString ].
    detail isNil ifTrue: 
		[ detail := '' ].
    ^Array with: desc with: aNode class name printString with: detail.
!

getNodes: aNode
    | nds |
    aNode isNil ifTrue: [ ^rootNode ifNotNil: [ :rn | Array with: rn ] ].
    nds := OrderedCollection new.
    aNode isElement ifTrue: [
	nds addAll: aNode attributes
    ].
    aNode hasSubNodes ifTrue: [ nds addAll: aNode children ].
    ^nds isEmpty ifTrue: [ nil ] ifFalse: [ nds ].
!

rootNode
	^rootNode
!

rootNode: aNode
	rootNode := aNode.
	self changeState: #dataChanged.
! 
!
