"======================================================================
|
| Copyright 2004 Mike Anderson
| Written by Mike Anderson
|
| This file is part of Mumble, a development environment for GNU Smalltalk.
|
| Mumble is free software; you can redistribute it and/or modify it
| under the terms of the GNU General Public License as published by the Free
| Software Foundation; either version 2, or (at your option) any later version.
| 
| Mumble is distributed in the hope that it will be useful, but WITHOUT
| ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
| FOR A PARTICULAR PURPOSE.  See the GNU General Public License for more
| details.
| 
| You should have received a copy of the GNU General Public License along with
| Mumble; see the file COPYING.  If not, write to the Free Software
| Foundation, 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.  
|
 ======================================================================
"


Object subclass: #SimpleTreeNode
	instanceVariableNames: 'parent children data'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Mumble-Ancilliary'
!

SimpleTreeNode class methodsFor: 'instance creation'!

new
	^(super new) initialize
!
!

SimpleTreeNode methodsFor: 'initialization'!

initialize
	children := OrderedCollection new.
	^self
!
!

SimpleTreeNode methodsFor: 'accessing'!

data
	^data
!

data: aData
	data := aData
!

parent
	^parent
!

parent: aSimpleTreeNode
	parent := aSimpleTreeNode
!

add: aChild
	aChild parent: self.
    children add: aChild
!

children
	^children
!
!
