"======================================================================
|
| Copyright 2004 Mike Anderson
| Written by Mike Anderson
|
| This file is part of Mumble, a development environment for GNU Smalltalk.
|
| Mumble is free software; you can redistribute it and/or modify it
| under the terms of the GNU General Public License as published by the Free
| Software Foundation; either version 2, or (at your option) any later version.
| 
| Mumble is distributed in the hope that it will be useful, but WITHOUT
| ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
| FOR A PARTICULAR PURPOSE.  See the GNU General Public License for more
| details.
| 
| You should have received a copy of the GNU General Public License along with
| Mumble; see the file COPYING.  If not, write to the Free Software
| Foundation, 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.  
|
 ======================================================================
"


WorkspaceView subclass: #TranscriptView
	instanceVariableNames: 'previousMsg'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Browser-Windows'!
		
!

TranscriptView methodsFor: 'initialization'!

buildSubsidiaryViews
	| pol |
	super buildSubsidiaryViews.
	
	previousMsg := Transcript message.
	Transcript message: self -> #nextPutAll:.

	pol := Gtk gtkPolicyAutomatic.
    eval scroll setPolicy: pol vscrollbarPolicy: pol.
!
!

TranscriptView methodsFor: 'accessing'!

nextPutAll: aString
	| it |
	[ it := GtkTextIter type new.
	eval text getEndIter: it.
	eval text insert: it text: aString len: -1. ]
		on: Error do: 
			[ :sig | previousMsg key perform: previousMsg value with: aString ].
!

destroy
	"FIXME This doesn't really work - we need to hook into when the
	 containing window gets closed."
	Transcript message: previousMsg.
	super destroy.
!
!
