"======================================================================
|
| Copyright 2004 Mike Anderson
| Written by Mike Anderson
|
| This file is part of Mumble, a development environment for GNU Smalltalk.
|
| Mumble is free software; you can redistribute it and/or modify it
| under the terms of the GNU General Public License as published by the Free
| Software Foundation; either version 2, or (at your option) any later version.
| 
| Mumble is distributed in the hope that it will be useful, but WITHOUT
| ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
| FOR A PARTICULAR PURPOSE.  See the GNU General Public License for more
| details.
| 
| You should have received a copy of the GNU General Public License along with
| Mumble; see the file COPYING.  If not, write to the Free Software
| Foundation, 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.  
|
 ======================================================================
"

"Install the GUI Inspector"
Object methodsFor: 'debugging'!

inspect
	(GTK.GUI.Mumble.WindowFactory buildInspectorWindow: self) show.
	GTK.GUI.Primitive updateViews.
	
	"Non-gui version: 
	inspect
	""Print all the instance variables of the receiver on the Transcript""
	| class instVars instVal |
	class := self class.
	instVars := class allInstVarNames.
	Transcript nextPutAll: 'An instance of '.
	class printNl.
	1 to: instVars size do:
		[ :i | Transcript nextPutAll: '  ';
				   nextPutAll: (instVars at: i);
				   nextPutAll: ': '.
			   (self instVarAt: i)  printNl ].
	
	1 to: self validSize do:
		[ :i | Transcript nextPutAll: '  [';
			   print: i;
			   nextPutAll: ']: ';
			   print: (self basicAt: i);
			   nl ]"
!
!

!Behavior methodsFor: 'overriding'!

debuggerClass
    ^GTK.GUI.Mumble.NotifierView handleErrors ifNotNil: 
		[ :b | 
		b 
			ifTrue: [ GTK.GUI.Mumble.NotifierView ] 
			ifFalse: [ nil ] ].
!
!

Namespace current: GTK.GUI.Mumble
!

Gtk initializeGtk.

(WindowFactory buildTranscriptWindow) show.
(WindowFactory buildNamespacesWindow) show.
(WindowFactory buildNamespaceWindow: Smalltalk) show.
(WindowFactory buildWorkspaceWindow: nil) show.
Primitive updateViews.

NotifierView handleErrors: true.
!

Namespace current: Smalltalk.
!


